<?php
/*
*  共通Class
*/
class MynumberCommonClass{

	public function __construct(){

		add_action('plugins_loaded', array('MynumberCommonClass', 'plugin_get_option'));

	}
	// オプション取得
	public static function plugin_get_option(){

		$get_data = self::get_option();
		// データがあれば
		if(!empty($get_data)){
			$GLOBALS['osmp_option_data'] = $get_data;
		}else{ // なければ
			$GLOBALS['osmp_option_data'] = array('licensekey'=>'', 'formpassword_flag'=>0, 'formpassword_num'=>0, 'formpassword'=>'', 'ippermit'=>'', 'ipblock'=>'', 'password_flag'=>'', 'password_num'=>'', 'password'=>'');
		}

	}
	//// データ取得
	public static function get_option(){

		$return_array = array();
		global $wpdb;
		$sql = "SELECT * FROM `".OSMP_MANAGEMENT_TABLE."` WHERE (`key`=%s OR `key`=%s OR `key`=%s) AND `delete_flag`=%d";
		$params = array('option', 'formpassword', 'password', 0);
		$get_data = $wpdb->get_results( $wpdb->prepare($sql, $params), ARRAY_A);
		//
		if(!empty($get_data)){
			foreach($get_data as $d){
				$key = (isset($d['key'])) ? $d['key']: '';
				$data = (isset($d['data'])) ? $d['data']: '';
				// キーによって処理が変わる
				switch($key){
					case 'option':
						$uns_data = unserialize($data);
						$return_array = array_merge($return_array, $uns_data);
						break;
					default:
						switch($key){
							case 'formpassword': case 'password':
								$key_name = $key.'_updatetime';
								$return_array[$key_name] = (isset($d['update_time'])) ? $d['update_time']: '';
								break;
						}
						$return_array[$key] = $data;
				}
			}
		}

		return $return_array;

	}
	/*
	*  ショートコードがあるか否か
	*/
	public static function has_shortcode($shortcode){

		global $wp_query;
		// 記事データを取得
		if(isset($wp_query->post)){
			$post = $wp_query->post;
			if(isset($post->post_content)){
				$post_data = $post->post_content;
			}
		}
		//　取得できなければ別の配列からもう一度試みる
		if(isset($wp_query->posts) && !isset($post_data)){
			$posts = $wp_query->posts;
			if(isset($posts[0]) && isset($posts[0]->post_content)){
				$post_data = $posts[0]->post_content;
			}
		}
		// 投稿データにショートコードが含まれるか
		if(isset($post_data)){
			// 含めばTRUE
			if(stristr($post_data, "[".$shortcode)){
				return TRUE;
			}else{
				return FALSE;
			}
		}else{
			return FALSE;
		}

	}
	/*
	*  独自リダイレクト（先にヘッダが送信されているとリダイレクトできないため）
	*/
	public static function os_redirect($url=''){

		if(self::header_check()==TRUE){
			print '<meta http-equiv="refresh" content="0;URL='.$url.'" />';
		}else{
			wp_safe_redirect($url);
		}

	}
	// ヘッダーが送信されているかチェック
	public static function header_check(){

		if(headers_sent($filename, $linenum)){
			//print_r(headers_list());
			//echo "$filename の $linenum 行目でヘッダがすでに送信されています。\n";
			return TRUE;
		}else{
			return FALSE;
		}

	}
	// 処理中の表示
	public static function now_processing(){
		echo "<div style=\"margin:20px 10px 0 0;\"><h2>処理中です…</h2></div>";
		exit;
	}
	/*
	*  ユーザメタを作成
	*/
	public static function user_meta_upd($arr=array(), $user_id=''){

		if(empty($user_id) || is_numeric($user_id)){
			$user = wp_get_current_user(); // ログインユーザデータ
			$user_id = (isset($user->ID)) ? $user->ID: 0;
		}
		//
		foreach($arr as $key => $val){
			$now_data = get_user_meta($user_id, $key, true);
			// 現在の値と比較し、同じなら実行しない（バグを避けるため）
			if($now_data!=$val){
				// 更新を実行して、失敗なら新規作成を試す
				if(update_user_meta($user_id, $key, $val)===FALSE){
					// 新規作成も実行して失敗ならFALSE
					if(add_user_meta($user_id, $key, $val, true)===FALSE){
						return FALSE;
					}
				}
			}
		}

		return TRUE;

	}
	/*
	*  権限規模を確認
	*/
	public static function exe_check_comp(){

		//
		switch(OSMP_COMPANIES){
			case 'smaller_companies':
				return 50;
				break;
			case 'big_company':
				return 1000;
				break;
			case 'no_limit':
				return 0;
				break;
			default:
				return FALSE;
		}

	}
	/*
	*  ランダムな英数字記号を生成
	*  指定がなければ8桁～14桁の数字にする
	*/
	public function pwd_rand($start_num='8', $end_num='14'){

		$value = '';
		// 英字
		$eng = range('a', 'z'); // 26文字
		$big_eng = range('A', 'Z'); // 26文字
		// 記号
		$symbol = array('[', ']', '(', ')', '&', '#', '$', '?', '.', ',', '\\', '/', '"', "'", '!', '-', '+', '=', '@', '^', '~', '*');
		$symbol_ct = count($symbol);
		// 同じなら$start_numの桁にする
		if($start_num==$end_num){
			$stop = $start_num;
		}else{ // 違うなら$start_num~$end_numの桁
			$stop = mt_rand($start_num, $end_num);
		}
		//
		for($i=0; $i<$stop; $i++){
			$r = mt_rand(0, 3);
			//
			switch($r){
				// 記号
				case 3:
					$end = $symbol_ct - 1;
					$e = mt_rand(0, $end);
					$value .= $symbol[$e];
					break;
				// 大文字英字
				case 2:
					$e = mt_rand(0, 25);
					$value .= $big_eng[$e];
					break;
				// 小文字英字
				case 1:
					$e = mt_rand(0, 25);
					$value .= $eng[$e];
					break;
				// 数字0~9
				default:
					$value .= mt_rand(0, 9);
			}
		}

		return $value;

	}
	/*
	*  ページ数、件数
	*/
	public static function page_count($page='', $limit='20'){

		// ページ数取得
		if(empty($page)){
			$page = (!empty($_REQUEST['pnum']) && is_numeric($_REQUEST['pnum'])) ? $_REQUEST['pnum']: 1;
		}
		//
		$end = $page * $limit;
		$start = ($end - $limit) + 1;

		return array('start'=>$start, 'end'=>$end, 'page'=>$page);

	}
	/*
	*  年月日のoptionタグ
	*/
	// 年
	public static function year_options($selected='', $start='', $str=''){

		$options = '';
		$now = date_i18n("Y");
		$start = (!empty($start) && is_numeric($start)) ? $start: $now;
		$end = $now + 2;
		$selected = (!empty($selected)) ? $selected: $now;
		//
		for($i=$start; $i<$end; $i++){
			$selected_html = ($selected==$i) ? 'selected': '';
			$options .= '<option value="'.$i.'" '.$selected_html.'>'.$i.$str.'</option>';
		}

		return $options;

	}
	// 月
	public static function month_options($selected='', $str=''){

		$options = '';
		$now = date_i18n("m");
		$selected = (!empty($selected)) ? $selected: $now;
		$selected = sprintf('%02d', $selected);
		//
		for($i=1; $i<13; $i++){
			$t = sprintf('%02d', $i);
			$selected_html = ($selected==$t) ? 'selected': '';
			$options .= '<option value="'.$t.'" '.$selected_html.'>'.$t.$str.'</option>';
		}

		return $options;

	}
	// 日
	public static function day_options($selected='', $str=''){

		$options = '';
		$now = date_i18n("d");
		$selected = (!empty($selected)) ? $selected: $now;
		$selected = sprintf('%02d', $selected);
		//
		for($i=1; $i<32; $i++){
			$t = sprintf('%02d', $i);
			$selected_html = ($selected==$t) ? 'selected': '';
			$options .= '<option value="'.$t.'" '.$selected_html.'>'.$t.$str.'</option>';
		}

		return $options;

	}
	/*
	*  $_REQUESTをURL用に変換
	*/
	public static function request_url($url='', $unset_param=array()){

		if(!empty($_REQUEST)){
			if(stristr($url, "?")){
				$url .= "&amp;";
			}else{
				$url .= "?";
			}
			// まずはアンセット処理
			if(!empty($unset_param)){
				foreach($unset_param as $uns){
					unset($_REQUEST[$uns]);
				}
			}
			//
			foreach($_REQUEST as $key => $req){
				$url .= urlencode($key)."=".urlencode($req)."&amp;";
			}
			$url = rtrim($url, "&amp;");
		}

		return $url;

	}
	// 念のためPHPバージョン確認をして実行、なければエラーを返す
	public static function phpversion_check($version=5, $str=''){

		if(phpversion()>=$version){
			return TRUE;
		}else{
			print $str."PHPバージョン".$version."以上が必要です。";
			exit;
		}

	}

}