<?php
/*
*  CSV Class
*/
class MynumberCsvClass{

	/*
	*  インポート処理
	*/
	// CSVを取り込み
	public static function input_csv($key='csv'){

		$array = array();
		$itemData = MynumberSql::get_formitem_data();
		$csv_option = MynumberCsvClass::get_csv_options();
		//
		if(isset($_FILES[$key]) && isset($_FILES[$key]["tmp_name"])){
			$csv = file_get_contents($_FILES[$key]["tmp_name"]);
			$buffer = mb_convert_encoding($csv, "UTF-8", mb_detect_encoding($csv, "auto"));
			$fp = tmpfile();
			fwrite($fp, $buffer);
			rewind($fp);
			$ins_count = 0; // 実行数
			$dup_count = 0; // 重複数
			$ln = 0;
			//
			while(($data = fgetcsv($fp, 0, ","))!==FALSE){
				if($ln!=0){
					$array = array();
					$item_array = array();
					//
					foreach($csv_option as $i => $op){
						$key = (isset($op['key'])) ? $op['key']: '';
						// 通常項目
						if(isset($op['type']) && $op['type']!=1){
							$array[$key] = (isset($data[$i])) ? $data[$i]: '';
						}else{ // ユーザ追加項目
							// 項目データから一致するデータを探す
							foreach($itemData as $item){
								if(isset($item['key']) && $item['key']==$key){
									$item_id = (isset($item['item_id'])) ? $item['item_id']: '';
									$value_type = (isset($item['value_type'])) ? $item['value_type']: 0;
									break;
								}
							}
							$value = (isset($data[$i])) ? $data[$i]: '';
							$item_array[] = array('item_id'=>$item_id, 'value_type'=>$value_type, 'value'=>$value);
						}
					}
					//
					$array['agreement'] = 1;
					$array['item'] = $item_array;
					$mynumber = (isset($array['mynumber'])) ? $array['mynumber']: '';
					// マイナンバーが重複していなければ実行
					if(MynumberSql::mynumber_data_check($mynumber)===FALSE){
						$data_id = MynumberSql::update_mynumber_data($array, 'insert');
						// 失敗
						if($data_id===FALSE){
							return FALSE;
							break;
						}
						$ins_count++;
					}else{
						$dup_count++;
					}
				}
				$ln++;
			}
			$total = $ln - 1;

			return array('total'=>$total, 'ins'=>$ins_count, 'dup'=>$dup_count);

		}else{
			return FALSE;
		}

	}
	/*
	*  エクスポート処理
	*/
	// CSV出力
	public static function output_csv(){

		// 管理者権限のみ表示
		if(self::role_check()===TRUE){
			MynumberCommonClass::phpversion_check(5, 'CSVエクスポート機能を使用するには、');
			global $wpdb;
			unset($_REQUEST['mode']);
			$type = (isset($_REQUEST['type'])) ? $_REQUEST['type']: '';
			$data_array = MynumberSql::get_mynumber_data($_REQUEST);
			//
			if(!empty($data_array['total'])){
				$data = $data_array['data'];
				// csvヘッダ設定
				$csv_header = array('データID', '姓', '名', 'マイナンバー', 'マイナンバー画像', '身分証明画像');
				$key_array = array('data_id', 'last_name', 'first_name', 'mynumber', 'mynumber_img_id', 'certification_img_id');
				$itemData = MynumberSql::get_formitem_data();
				foreach($itemData as $item){
					$name = (isset($item['name'])) ? $item['name']: '';
					$key = (isset($item['key'])) ? 'item_'.$item['key']: '';
					$csv_header = array_merge($csv_header, array("{$name}"));
					$key_array = array_merge($key_array, array("{$key}"));
				}
				// 最後尾に提出日時
				$csv_header = array_merge($csv_header, array('提出日時'));
				$key_array = array_merge($key_array, array('create_time'));
				// ヘッダをcsvに
				$fp = fopen('php://temp', 'r+b');
				fputcsv($fp, $csv_header);
				// データをcsvに
				foreach($data as $d){
					$fields = array();
					//
					foreach($key_array as $key){
						// 独自項目
						if(stristr($key, 'item_')){
							$key = str_replace('item_', '', $key);
							$row = (isset($d['detail']) && isset($d['detail'][$key]))? $d['detail'][$key]: '';
							$value_type = (isset($row['value_type'])) ? $row['value_type']: 0;
							//
							switch($value_type){
								case 3:
									$img_id = (isset($row['detail_data_id'])) ? $row['detail_data_id']: 0;
									$fields[] = self::image_link($img_id, $type, 'item');
									break;
								case 2:
									$value = (isset($row['value_time'])) ? $row['value_time']: '';
									$fields[] = self::is_excel_csv($value, $key, $type);
									break;
								case 1:
									$fields[] = (isset($row['value_int'])) ? $row['value_int']: '';
									break;
								default:
									$value = (isset($row['value_text'])) ? $row['value_text']: '';
									$fields[] = self::is_excel_csv($value, $key, $type);
							}
						}else{
						// 標準項目
							switch($key){
								// 画像データ
								case 'mynumber_img_id': case 'certification_img_id':
									$img_id = (isset($d[$key])) ? $d[$key]: 0;
									$fields[] = self::image_link($img_id, $type);
									break;
								default:
									$value = (isset($d[$key])) ? $d[$key]: '';
									$fields[] = self::is_excel_csv($value, $key, $type);
							}
						}
					}
					fputcsv($fp, $fields);
				}
				rewind($fp);
				$csv_data = str_replace(PHP_EOL, "\r\n", stream_get_contents($fp));
				//print_r($csv_data);
				//exit;
				header('Content-Type: application/octet-stream');
				header('Content-Disposition: attachment; filename=data.csv');
				echo mb_convert_encoding(trim($csv_data), 'SJIS-win', 'UTF-8');
				exit;
			}else{
				print "エラー！";
				exit;
			}
		}

	}
	// サンプルCSV出力
	public static function sample_output_csv(){

		// 管理者権限のみ表示
		if(self::role_check()===TRUE){
			MynumberCommonClass::phpversion_check(5, 'CSVエクスポート機能を使用するには、');
			global $wpdb;
			$csv_option = MynumberCsvClass::get_csv_options();
			// サンプルcsvデータ設定
			$csv_header = array();
			$csv_array = array();
			foreach($csv_option as $t => $op){
				$name_value = (isset($op['name'])) ? $op['name']: '';
				$key_value = (isset($op['key'])) ? $op['key']: '';
				$csv_header[] = $name_value;
				//
				switch($key_value){
					case 'last_name':
						$csv_array[] = '鈴木';
						break;
					case 'first_name':
						$csv_array[] = '一郎';
						break;
					case 'mynumber':
						$csv_array[] = '123456789123';
						break;
					case 'create_time':
						$csv_array[] = '2016-01-01 09:15:30';
						break;
					default:
						$csv_array[] = '';
				}
			}
			// ヘッダをcsvに
			$fp = fopen('php://temp', 'r+b');
			fputcsv($fp, $csv_header);
			fputcsv($fp, $csv_array);
			rewind($fp);
			$csv_data = str_replace(PHP_EOL, "\r\n", stream_get_contents($fp));
			//print_r($csv_data);
			//exit;
			header('Content-Type: application/octet-stream');
			header('Content-Disposition: attachment; filename=data.csv');
			echo mb_convert_encoding(trim($csv_data), 'SJIS-win', 'UTF-8');
			exit;

		}

	}
	// type=excel_csvなら、エクセル形式に変換
	public static function is_excel_csv($value='', $key='', $type=''){

		if($type=='excel_csv'){
			switch($key){
				// 提出日時
				case 'create_time':
					return '=TEXT("'.$value.'","yyyy年mm月dd日hh時mm分ss秒")';
					break;
				// マイナンバー
				case 'mynumber':
					return '=TEXT("'.$value.'","####")';
					break;
				default:
					return $value;
			}
		}else{
			return $value;
		}

	}
	// 画像リンク
	public static function image_link($img_id='0', $type='', $tbl=''){

		$image_link = admin_url().'admin.php?page=os-mynumber-list.php&amp;mode=image&amp;id='.$img_id;
		//
		if(!empty($tbl)){
			$image_link .= '&amp;tbl='.$tbl;
		}
		//
		switch($type){
			case 'excel_csv':
				return '=HYPERLINK("'.$image_link.'","画像リンク")';
				break;
			default:
				return $image_link;
		}

	}
	// 権限チェック
	// $pass_roleの権限のみ許可する
	public static function role_check($pass_role='administrator'){

		$user = wp_get_current_user(); // ログインユーザデータ
		$roles = (isset($user->roles) && isset($user->roles[0])) ? $user->roles[0]: '';
		// 配列なら
		if(is_array($pass_role)){
			foreach($pass_role as $r){
				if($r==$roles){
					return TRUE;
					break;
				}
			}
		}else{ // 配列じゃなければ
			// 一致するなら
			if($roles==$pass_role){
				return TRUE;
			}
		}

		return FALSE;

	}
	/*
	*  CSVの設定
	*/
	// 設定更新
	public static function update_csv_options($post=''){

		if(!empty($post['line'])){
			$array = array();
			//
			foreach($post['line'] as $i){
				$key = (isset($post['key']) && isset($post['key'][$i])) ? $post['key'][$i]: '';
				$name = (isset($post['name']) && isset($post['name'][$i])) ? $post['name'][$i]: '';
				$type = (isset($post['type']) && isset($post['type'][$i])) ? $post['type'][$i]: '';
				$array[$i] = array('key'=>$key, 'name'=>$name, 'type'=>$type);
			}
			// 更新
			if(update_option(OSMP_CSV, $array)){
				return TRUE;
			}else{
				return FALSE;
			}
		}else{
			return FALSE;
		}

	}
	// 設定取得
	public static function get_csv_options(){

		if($options = get_option(OSMP_CSV)){
			return $options;
		}else{
			$options = array(
				'0'=>array('key'=>'last_name', 'name'=>'姓', 'type'=>0),
				'1'=>array('key'=>'first_name', 'name'=>'名', 'type'=>0),
				'2'=>array('key'=>'mynumber', 'name'=>'マイナンバー', 'type'=>0),
				'3'=>array('key'=>'create_time', 'name'=>'提出日時', 'type'=>0),
			);
			return $options;
		}

	}

}