<?php
/*
*  パスワードフォームClass
*/
class PasswordForm extends MynumberCommonClass {


	public function __construct(){

		parent::__construct();

	}
	/*
	*  プラグイン管理画面でのパスワードチェック
	*/
	// 管理画面がパスワード制限があるか否か
	// 制限無効ならFALSE、制限有効ならTRUE
	public static function password_admin(){

		global $osmp_option_data;
		$option = $osmp_option_data;
		// パスワードが有効で設定されている
		if(!empty($option['password_flag']) && !empty($option['password'])){
			$user = wp_get_current_user(); // ログインユーザデータ
			$my_id = (isset($user->ID)) ? $user->ID: 0;
			// データがあり、かつ1なら制限解除済としてFALSE
			// ただし、解除フラグの作成日時あとにパスワードが変更されているならTRUE
			if($unlock_flag = get_user_meta($my_id, 'password_admin_unlock_flag', true)){
				$create_data = get_user_meta($my_id, 'password_admin_unlock_flag_createdata', true);
				$password_updatetime = (isset($option['password_updatetime'])) ? $option['password_updatetime']: '';
				// 日時をチェック
				if($create_data<$password_updatetime){ // 再入力へ
					return TRUE;
				}else{ // OK
					return FALSE;
				}
			}else{
				return TRUE;
			}
		}else{ // OK
			return FALSE;
		}

	}
	// パスワードをチェックする
	// 一致するならTRUE
	public static function password_check($password='', $key='password'){

		if(!empty($password)){
			global $wpdb;
			$sql = "SELECT `data` FROM `".OSMP_MANAGEMENT_TABLE."` WHERE `key`=%s AND `delete_flag`=%d";
			$data = $wpdb->get_results( $wpdb->prepare($sql, array($key, 0)), ARRAY_A);
			// データが取得できれば
			if(!empty($data) && isset($data[0]) && isset($data[0]['data'])){
				// チェック
				if(wp_check_password($password, $data[0]['data'])!==FALSE){
					return TRUE;
				}else{
					return FALSE;
				}
			}else{
				return FALSE;
			}
		}else{
			return FALSE;
		}

	}
	// パスワード再発行
	public static function password_reissue(){

		$password = self::pwd_rand(8, 12); // 自動生成
		// パスワードのアップデート
		if(!empty($password)){
			global $wpdb;
			$sql = "UPDATE `".OSMP_MANAGEMENT_TABLE."` SET `data`=%s WHERE `key`=%s AND `delete_flag`=%d";
			$result = $wpdb->query( $wpdb->prepare($sql, array(wp_hash_password($password), 'password', 0)) );
			// 失敗
			if($result===FALSE){
				self::error_behavior($wpdb);
				return FALSE;
			}
			// メール送信
			$now = date_i18n("Y-m-d H:i:s");
			$admin_email = get_option('admin_email');
			$from_email = 'no-reply@'.$_SERVER['SERVER_NAME'];
			$subject = '[マイナンバー管理プラグイン] パスワード再発行メール';
			$headers = 'From: マイナンバー管理プラグインのパスワード再発行メール <'.$from_email.'>'."\r\n";
			$message = "マイナンバー管理プラグインの管理画面パスワード（第二パスワード）を再発行しました。\r\n\r\n"
				."発行申請日時：".$now."\r\n"
				."新しいパスワード：".$password."\r\n"
				."管理画面URL:".get_admin_url()."admin.php?page=os-mynumber-admin.php\r\n"
				."\r\n"
				."このメールアドレスに返信しないでください。\r\n"
				."\r\n"
			;
			wp_mail($admin_email, $subject, $message, $headers);
			//
			return TRUE;
		}

	}

}