<?php
if(class_exists('MynumberAdmin')){
?>

	<div id="mynumber-plugin">
	<?php include_once(OSMP_PLUGIN_INCLUDE_FILES."/admin-head.php"); ?>
		<div class="mynumber-wrap">
			<h2>マイナンバー提出フォームの設定</h2>
			<div class="mynumber-contents">
				<div>
					提出フォーム用ページはインストール時に作成されています。<a href="<?php echo home_url(); ?>/?p=<?php echo esc_html($get_page_id); ?>" target="_blank">こちらで確認</a>してください。<br />ページが存在しない場合は、記事中に[mynumber-form]というショートコードを入れます。
				</div>
				<h3>項目の一覧</h3>
				<div style="color:red;">
				<?php echo $message; ?><?php MynumberValidation::output_msg($validate); ?>
				</div>
<?php MynumberValidation::output_css($validate); ?>
				<form action="?page=os-mynumber-admin-form.php" method="POST">
<?php
				if(!empty($data)){
					$order_array = array(0);
?>
					<table class="mynumber-table">
						<tr>
							<th class="center">項目ID</th><th class="center">項目名</th><th class="center">項目キー</th><th class="center">値タイプ</th><th class="center">昇順</th><th class="center">編集</th><th class="center">作成日時</th><th class="center">更新日時</th>
						</tr>
<?php
						foreach($data as $i => $d){
							$item_id = (isset($d['item_id'])) ? $d['item_id']: '-';
							$name = (isset($d['name'])) ? $d['name']: '';
							$key = (isset($d['key'])) ? $d['key']: 'key'.$i;
							$value_type = (isset($d['value_type'])) ? $d['value_type']: 0;
							//
							switch($value_type){
								case 3:
									$value_type_text = '画像';
									break;
								case 2:
									$value_type_text = '日時';
									break;
								case 1:
									$value_type_text = '数値';
									break;
								default:
									$value_type_text = 'テキスト';
							}
							//
							$order = (isset($d['order'])) ? $d['order']: 0;
							$order_array = array_merge($order_array, array($order)); // 最大値をだすのに使用
							$create_time = (isset($d['create_time'])) ? $d['create_time']: '-';
							$update_time = (isset($d['update_time'])) ? $d['update_time']: '-';
?>
						<tr id="item<?php echo esc_html($i); ?>">
							<td class="center">
								<?php echo esc_html($item_id); ?>
								<input type="hidden" name="item[<?php echo esc_html($i); ?>][item_id]" value="<?php echo esc_html($item_id); ?>" />
							</td>
							<td>
								<span class="now error-close"><?php echo esc_html($name); ?></span>
								<span class="write error-open">
									<input type="text" name="item[<?php echo esc_html($i); ?>][name]" id="item-name<?php echo esc_html($i); ?>" value="<?php echo esc_html($name); ?>" class="inp150" />
								</span>
							</td>
							<td>
								<span class="now error-close"><?php echo esc_html($key); ?></span>
								<span class="write error-open">
									<input type="text" name="item[<?php echo esc_html($i); ?>][key]" id="item-key<?php echo esc_html($i); ?>" value="<?php echo esc_html($key); ?>" class="inp100" />
								</span>
							</td>
							<td>
								<span class="now error-close"><?php echo $value_type_text; ?></span>
								<span class="write error-open">
									<select name="item[<?php echo esc_html($i); ?>][value_type]">
										<option value="0" <?php if($value_type==0){ echo 'selected'; } ?>>テキスト</option><option value="1" <?php if($value_type==1){ echo 'selected'; } ?>>数値</option><option value="2" <?php if($value_type==2){ echo 'selected'; } ?>>日時</option><option value="3" <?php if($value_type==3){ echo 'selected'; } ?>>画像</option>
									</select>
								</span>
							</td>
							<td class="center">
								<span class="now error-close"><?php echo $order; ?></span>
								<span class="write error-open">
									<select name="item[<?php echo esc_html($i); ?>][order]">
<?php
							for($op=0; $op<100; $op++){
								$selected = ($op==$order) ? 'selected': '';
								echo "\t\t\t\t\t\t\t\t\t<option value=\"{$op}\" {$selected}>{$op}</option>\n";
							}
?>
									</select>
								</span>
							</td>
<?php
							$updflag = (!empty($d['updflag'])) ? 1: 0;
?>
							<td>
								<span class="now error-close"><input type="button" value="編集する" onclick="item_write_open('item<?php echo esc_html($i); ?>')" class="wr-button wr-button-now" /></span>
								<span class="write error-open"><input type="button" value="キャンセル" onclick="item_write_close('item<?php echo esc_html($i); ?>')" class="wr-button wr-button-wr" /></span>
								<input type="hidden" name="item[<?php echo esc_html($i); ?>][updflag]" id="updflag<?php echo esc_html($i); ?>" class="updflag" value="<?php echo $updflag; ?>" />
							</td>
							<td class="fnt13">
								<?php echo esc_html($create_time); ?>
							</td>
							<td class="fnt13">
								<?php echo esc_html($update_time); ?>
							</td>
						</tr>
<?php
						}
?>
					</table>
					<?php wp_nonce_field($upd_action, '_wpnonce', false); echo "\n"; ?>
					<input type="hidden" name="page" value="os-mynumber-admin-form.php" />
					<input type="hidden" name="mode" value="upd" />
					<div class="submit">
						<input type="submit" name="submit" value="編集したデータを更新する" />
					</div>
<?php
				}else{
?>
					<p style="color:red;">フォーム項目のデータがありません</p>
<?php
				}
?>
				</form>
				<h3>項目の新規追加</h3>
				<div style="color:red;"><?php MynumberValidation::output_msg($ins_validate); ?></div>
<?php MynumberValidation::output_css($ins_validate); ?>
				<form action="?page=os-mynumber-admin-form.php" method="POST">
<?php
				if(!empty($order_array)){
					$max = max($order_array);
				}else{
					$max = 0;
				}
				$order_select_i = ($max<100) ? $max + 1: 99;
				// 項目のPOSTされた値があれば
				$ins_name = (isset($new_form['name'])) ? esc_html($new_form['name']): '';
				$ins_key = (isset($new_form['key'])) ? esc_html($new_form['key']): '';
				$ins_value_type = (isset($new_form['value_type'])) ? esc_html($new_form['value_type']): '';
				$ins_order = (isset($new_form['order'])) ? esc_html($new_form['order']): '';
?>
					<div class="mynumber-ins">
						<p><label for="ins-name">項目名：</label><input type="text" name="name" id="ins-name" value="<?php echo $ins_name; ?>" class="inp150" /></p>
						<p><label for="ins-key">項目キー：</label><input type="text" name="key" id="ins-key" value="<?php echo $ins_key; ?>" class="inp100" /></p>
						<p><label for="ins-value_type">値タイプ：</label>
							<select name="value_type" id="ins-value_type">
								<option value="0" <?php if($ins_value_type==0){ echo 'selected'; } ?>>テキスト</option>
								<option value="1" <?php if($ins_value_type==1){ echo 'selected'; } ?>>数値</option>
								<option value="2" <?php if($ins_value_type==2){ echo 'selected'; } ?>>日時</option>
								<option value="3" <?php if($ins_value_type==3){ echo 'selected'; } ?>>画像</option>
							</select>
						</p>
						<p><label for="ins-order">昇順：</label>
							<select name="order" id="ins-order">
<?php
							for($op=0; $op<100; $op++){
								if(is_numeric($ins_order)){
									$selected = ($ins_order==$op) ? 'selected': '';
								}else{
									$selected = ($order_select_i==$op) ? 'selected': '';
								}
								echo "\t\t\t\t\t\t\t<option value=\"{$op}\" {$selected}>{$op}</option>\n";
							}
?>
							</select>
						</p>
						<div class="submit">
							<input type="submit" name="submit" value="項目を追加する" />
						</div>
					</div>
					<?php wp_nonce_field($ins_action, '_wpnonce', false); echo "\n"; ?>
					<input type="hidden" name="page" value="os-mynumber-admin-form.php" />
					<input type="hidden" name="mode" value="ins" />
				</form>
				<h3>項目の削除</h3>
				<form action="?page=os-mynumber-admin-form.php" method="POST">
<?php
				if(!empty($data)){
?>
					<div class="mynumber-del">
						<label for="delete_id">削除する項目：</label>
						<select name="delete_id" id="delete_id">
							<option>選択してください</option>
<?php
					foreach($data as $d){
						$item_id = (isset($d['item_id'])) ? $d['item_id']: '';
						$name = (isset($d['name'])) ? $d['name']: '';
?>
							<option value="<?php echo $item_id; ?>">項目ID:<?php echo esc_html($item_id); ?>&nbsp;項目名:<?php echo esc_html($name); ?></option>
<?php
					}
?>
						</select>
						&nbsp;
						<input type="submit" name="submit" value="項目を削除する" class="inp-submit" />
					</div>
					<?php wp_nonce_field($del_action, '_wpnonce', false); echo "\n"; ?>
					<input type="hidden" name="page" value="os-mynumber-admin-form.php" />
					<input type="hidden" name="mode" value="del" />
<?php
				}
?>
				</form>
			</div>
		</div>
	</div>
<script>
// 編集項目の表示
function item_write_open(ids){
	j('#'+ids+' .now').hide();
	j('#'+ids+' .write').show();
	j('#'+ids+' .updflag').val(1);
}
// 編集項目の非表示
function item_write_close(ids){
	j('#'+ids+' .now').show();
	j('#'+ids+' .write').hide();
	j('#'+ids+' .updflag').val(0);
}
</script>
<?php MynumberValidation::output_jquery($validate, 'item'); ?>
<?php MynumberValidation::output_jquery($ins_validate, 'item'); ?>

<?php
}
?>