<?php
if(class_exists('MynumberPublic')){
?>
	<a id="form-top" name="form-top"></a>
	<div id="mynumber-plugin">
		<div id="error-msg" class="red"></div>
		<form action="<?php echo esc_url(home_url().$_SERVER['REQUEST_URI']); ?>" method="POST" enctype="multipart/form-data" id="mynumber-form" class="mynumber-form">
			<!-- アップロードするファイルサイズは12MBまで有効 -->
			<input type="hidden" name="MAX_FILE_SIZE" value="12000000" />
			<table>
			<tr>
				<td>
					<label for="last_name">姓</label><br>
					<input type="text" name="last_name" id="last_name" class="input" value="" />
				</td>
				<td>
					<label for="first_name">名</label><br>
					<input type="text" name="first_name" id="first_name" class="input" value="" />
				</td>
			</tr>
			<tr>
				<td colspan="2">
					<label for="mynumber">マイナンバー（12桁の数字）</label><br>
					<input type="text" name="mynumber" id="mynumber" class="numeric input" value="" style="ime-mode:inactive;" />
				</td>
			</tr>
<?php
			foreach($data as $d){
				$item_id = (isset($d['item_id'])) ? $d['item_id']: 0;
				$key = (isset($d['key'])) ? $d['key']: '';
				$name = (isset($d['name'])) ? $d['name']: '';
				$value_type = (isset($d['value_type'])) ? $d['value_type']: '';
				$input = '';
				//
				switch($value_type){
					// 画像
					case 3:
						$input .= '<input type="file" name="item[item_img]['.esc_html($item_id).']" id="item_img_'.esc_html($key).'" accept="image/*" />';
						$input .= '<input type="hidden" name="item['.esc_html($key).'][value]" id="item_'.esc_html($key).'" value="" />';
						break;
					// 数字のみ
					case 1:
						$input .= '<input type="number" name="item['.esc_html($key).'][value]" id="item_'.esc_html($key).'" class="input" value="" />';
						break;
					// テキスト
					default:
						$input .= '<input type="text" name="item['.esc_html($key).'][value]" id="item_'.esc_html($key).'" class="input" value="" />';
				}
				$input .= '<input type="hidden" name="item['.esc_html($key).'][item_id]" value="'.esc_html($item_id).'" />';
				$input .= '<input type="hidden" name="item['.esc_html($key).'][value_type]" value="'.esc_html($value_type).'" />';
?>
			<tr>
				<td colspan="2">
					<label for="item_<?php echo esc_html($key); ?>"><?php echo esc_html($name); ?></label><br>
					<?php echo $input; ?>
				</td>
			</tr>
<?php
			}
?>
			<tr>
				<td colspan="2">
					<label for="mynumber_img">個人番号（マイナンバー）カードの画像</label><br>
					<input type="file" name="mynumber_img" id="mynumber_img" accept="image/*" />
					<br /><small>&nbsp;&nbsp;画像サイズは12MB以下にすること</small>
				</td>
			</tr>
			<tr>
				<td colspan="2">
					<label for="certification_img">身分証明書の画像</label><br>
					<input type="file" name="certification_img" id="certification_img" accept="image/*" />
					<br /><small>&nbsp;&nbsp;画像サイズは12MB以下にすること</small>
				</td>
			</tr>
			<tr>
				<td colspan="2">
					<strong>マイナンバー使用目的</strong><br>
					<ul>
						<li>源泉徴収票、支払調書などの法定調書のため</li>
						<li>健康保険、厚生年金保険などの届出事務のため</li>
					</ul>
					以上、マイナンバーを利用しますがよろしいでしょうか<br>
					<div id="agreement">
						&nbsp;
						<input type="radio" name="agreement" id="agreement1" value="1" /><label for="agreement1">同意します</label>
						&nbsp;&nbsp;
						<input type="radio" name="agreement" id="agreement0" value="0" checked /><label for="agreement0">同意しません</label>
					</div>
				</td>
			</tr>
			</table>
			<?php wp_nonce_field($action, '_wpnonce', false); echo "\n"; ?>
			<input type="hidden" name="mode" value="post" />
			<input type="button" name="btn" class="submit" value="送信する" />
		</form>
	</div>

<script>
// 空チェック
function valid_empty(ids, txt, flg, bder){
	if(jQuery("input[name='"+ids+"']").val() == ""){
		error_text = jQuery('#error-msg').html();
		jQuery('#error-msg').html(error_text+'<p>'+txt+'</p>');
		jQuery('#'+ids).css('border', '1px solid red');
		return 1;
	}
	else{
		if(bder==1){
			jQuery('#'+ids).css('border', '1px solid #D1D1D1');
		}
		else{
			jQuery('#'+ids).css('border', 'none');
		}
		return flg;
	}
}
jQuery(document).ready(function() {
	// 数字だけを許可
	jQuery(".numeric").numeric();
	// フォーム内容チェック及びフォーム送信処理
	jQuery('#mynumber-form .submit').click(function() {
		error_flag = 0;
		var error_text = '';
		jQuery('#error-msg').html(''); // 空に戻す
		// 姓が空のとき
		error_flag += valid_empty('last_name', '姓を入力してください', error_flag, 1);
		// 名が空のとき
		error_flag += valid_empty('first_name', '名を入力してください', error_flag, 1);
		// マイナンバーが空のとき
		mynumber_error_flag = valid_empty('mynumber', 'マイナンバーを入力してください', 0, 1);
		error_flag += mynumber_error_flag;
		// マイナンバーの桁数チェック
		if(mynumber_error_flag==0){
			if(jQuery("input[name='mynumber']").val().length==12){
				jQuery('#mynumber').css('border', '1px solid #D1D1D1');
			}
			else{
				error_text = jQuery('#error-msg').html();
				jQuery('#error-msg').html(error_text+'<p>マイナンバーは半角数字12桁で入力してください</p>');
				jQuery('#mynumber').css('border', '1px solid red');
				error_flag += 1;
			}
		}
		// マイナンバー画像が空のとき
		error_flag += valid_empty('mynumber_img', '個人番号（マイナンバー）カード画像を投稿してください', error_flag);
		// マイナンバー画像が空のとき
		error_flag += valid_empty('certification_img', '身分証明書画像を投稿してください', error_flag);
		// 同意チェック
		if(jQuery("input[name='agreement']:checked").val()==0){
			error_text = jQuery('#error-msg').html();
			jQuery('#error-msg').html(error_text+'<p>同意がないと、データは送信できません。</p>');
			jQuery('#agreement').css('border', '1px solid red');
			error_flag += 1;
		}
		else{
			jQuery('#agreement').css('border', 'none');
		}
		// エラーがあれば
		if(0 < error_flag){
			jQuery('#error-msg').css('margin-top', '15px');
			var target_offset = jQuery("#form-top").offset();
			var target_top = target_offset.top;
			jQuery("html, body").animate({scrollTop:target_top}, 10, "swing");
		}
		else{ // 送信
			jQuery('#mynumber-form').submit();
		}
	});
});
</script>

<?php
}
?>