<?php
//
class MynumberAdmin extends MynumberCommonClass {


	public function __construct(){

		parent::__construct();
		// まず実行
		add_action('admin_init', array('MynumberAdmin', 'actionAdminInit'));
		// 管理画面メニュー
		add_action('admin_menu', array('MynumberAdmin', 'menuViews'));
		// 管理画面フッター
		add_filter('in_admin_footer', array('MynumberAdmin', 'custom_in_admin_footer'));
		add_filter('admin_footer_text', array('MynumberAdmin', 'custom_admin_footer_text'));
		add_filter('update_footer', array('MynumberAdmin', 'custom_update_footer'));

	}
	/*
	*  プラグインメニュー
	*/
	// メニュー表示
	public static function menuViews(){

		if(self::exe_check_comp()!==FALSE){
			// プラグイン管理画面にパスワードが設定されていて、解除されてなければ
			if(PasswordForm::password_admin()!==FALSE){
				// メニュー表示
				add_menu_page('マイナンバー管理プラグイン', 'マイナンバー管理プラグイン', 'administrator', 'os-mynumber-admin.php', array('MynumberAdmin', 'adminPasswordFormPage'));
				add_submenu_page('os-mynumber-admin.php', 'マイナンバー一覧', null, 'administrator', 'os-mynumber-list.php', array('MynumberAdmin', 'adminSubPasswordFormPage'));
				add_submenu_page('os-mynumber-admin.php', 'CSVインポート', null, 'administrator', 'os-mynumber-admin-csv.php', array('MynumberAdmin', 'adminSubPasswordFormPage'));
				add_submenu_page('os-mynumber-admin.php', '提出フォームの設定', null, 'administrator', 'os-mynumber-admin-form.php', array('MynumberAdmin', 'adminSubPasswordFormPage'));
				add_submenu_page('os-mynumber-admin.php', 'プラグイン設定', null, 'administrator', 'os-mynumber-admin-option.php', array('MynumberAdmin', 'adminSubPasswordFormPage'));
			}else{
				// メニュー表示
				add_menu_page('マイナンバー管理プラグイン', 'マイナンバー管理プラグイン', 'administrator', 'os-mynumber-admin.php', array('MynumberAdmin', 'adminPage'));
				add_submenu_page('os-mynumber-admin.php', 'マイナンバー一覧', 'マイナンバー一覧', 'administrator', 'os-mynumber-list.php', array('MynumberAdmin', 'listPage'));
				add_submenu_page('os-mynumber-admin.php', 'CSVインポート', 'CSVインポート', 'administrator', 'os-mynumber-admin-csv.php', array('MynumberAdmin', 'csvPage'));
				add_submenu_page('os-mynumber-admin.php', '提出フォームの設定', '提出フォームの設定', 'administrator', 'os-mynumber-admin-form.php', array('MynumberAdmin', 'formPage'));
				add_submenu_page('os-mynumber-admin.php', 'プラグイン設定', 'プラグイン設定', 'administrator', 'os-mynumber-admin-option.php', array('MynumberAdmin', 'optionPage'));
			}
		}else{ // チェックの結果、拒否
			if(isset($_REQUEST['paged']) && $_REQUEST['paged']=='error'){
				// 既にエラーページなら、リダイレクトしない
			}else{
				$page = (isset($_REQUEST['page'])) ? $_REQUEST['page']: '';
				// 当プラグインなら
				if(stristr($page, 'os-mynumber-')){
					self::os_redirect('admin.php?page=os-mynumber-admin.php&paged=error&mode=comp');
					exit;
				}
			}
			//
			add_menu_page('マイナンバー管理プラグイン', 'マイナンバー管理プラグイン', 'administrator', 'os-mynumber-admin.php', array('MynumberAdmin', 'adminNotFoundPage'));
		}

	}
	/*
	*  ページビュー
	*/
	// Page はじめに
	public static function adminPage(){

		global $osmp_option_data;
		$message = '';
		$mode = (isset($_REQUEST['mode'])) ? $_REQUEST['mode']: '';
		$user = wp_get_current_user(); // ログインユーザデータ
		$my_id = (isset($user->ID)) ? $user->ID: 0;
		//
		switch($mode){
			// 利用規約
			case 'agreement':
				include_once(OSMP_PLUGIN_INCLUDE_FILES."/admin-agreementPage.php");
				break;
			// はじめに
			default:
				include_once(OSMP_PLUGIN_INCLUDE_FILES."/admin-adminPage.php");
		}

	}
	// Page マイナンバー一覧
	public static function listPage(){

		global $osmp_option_data;
		$message = MynumberMessageClass::updateMessage();
		$mode = (isset($_REQUEST['mode'])) ? $_REQUEST['mode']: '';
		$id = (isset($_REQUEST['id'])) ? $_REQUEST['id']: '';
		$user = wp_get_current_user(); // ログインユーザデータ
		$my_id = (isset($user->ID)) ? $user->ID: 0;
		//
		if($mode!='search'){
			$data = MynumberSql::get_mynumber_data($_REQUEST);
		}
		//
		switch($mode){
			// 検索
			case 'search':
				$redirect_url = self::request_url('admin.php?page=os-mynumber-list.php', array('mynumber0', 'mynumber1', 'mynumber2', 'create_time0', 'create_time1', 'create_time2', 'mode', 'page'));
				print "処理中です…";
				self::os_redirect($redirect_url);
				exit;
				break;
			// 削除
			case 'delete':
				$delete_action = $my_id.'_mynumber-data-delete';
				$url = 'admin.php?page=os-mynumber-list.php&mode=delete&id='.esc_html($id);
				// POST時
				if(!empty($_POST) && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'], $delete_action)){
					// 削除実行
					if(MynumberSql::delete_mynumber_data($id)){
						self::os_redirect($url.'&msg=delete-ok');
					}else{ // 失敗
						self::os_redirect($url.'&msg=delete-ng');
					}
					exit;
				}elseif(!empty($_POST)){
					self::os_redirect($url.'&msg=nonce-ng');
					exit;
				}
				$row = (isset($data['data']) && isset($data['data'][0])) ? $data['data'][0]: array();
				include_once(OSMP_PLUGIN_INCLUDE_FILES."/admin-deletePage.php");
				break;
			// 編集
			case 'write':
				$wr_action = $my_id.'_mynumber-data-wr';
				$url = 'admin.php?page=os-mynumber-list.php&mode=write&id='.esc_html($id);
				// POST時
				if(!empty($_POST) && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'], $wr_action)){
					// 更新実行
					if(MynumberSql::update_mynumber_data($_REQUEST, 'update')){
						self::os_redirect($url.'&msg=update-ok');
					}else{ // 失敗
						self::os_redirect($url.'&msg=update-ng');
					}
					exit;
				}elseif(!empty($_POST)){
					self::os_redirect($url.'&msg=nonce-ng');
					exit;
				}
				$row = (isset($data['data']) && isset($data['data'][0])) ? $data['data'][0]: array();
				$itemData = MynumberSql::get_formitem_data();
				include_once(OSMP_PLUGIN_INCLUDE_FILES."/admin-writePage.php");
				break;
			// 一覧
			default:
				$search_message = self::seach_pmatch(MynumberMessageClass::search_message(self::list_search_keyword()));
				$page_data = self::page_count();
				$itemData = MynumberSql::get_formitem_data();
				include_once(OSMP_PLUGIN_INCLUDE_FILES."/admin-listPage.php");
		}

	}
	// Page CSVインポート
	public static function csvPage(){

		include_once(OSMP_PLUGIN_DIR."class/csvClass.php");
		$csv_option = MynumberCsvClass::get_csv_options();
		$message = MynumberMessageClass::updateMessage();
		$message2 = MynumberMessageClass::updateMessage2();
		$mode = (isset($_REQUEST['mode'])) ? $_REQUEST['mode']: '';
		$user = wp_get_current_user(); // ログインユーザデータ
		$my_id = (isset($user->ID)) ? $user->ID: 0;
		$im_action = 'csv-import';
		$op_action = 'csv-option';
		//
		switch($mode){
			// CSVインポート
			case 'csv-import':
				// nonceの認証成功
				if(isset($_POST) && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'], $im_action)){
					$message .= '処理中です…';
					// 取り込み
					if($import_array = MynumberCsvClass::input_csv('import_csv')){
						$total = (isset($import_array['total'])) ? $import_array['total']: 0;
						$ins = (isset($import_array['ins'])) ? $import_array['ins']: 0;
						$dup = (isset($import_array['dup'])) ? $import_array['dup']: 0;
						self::os_redirect('admin.php?page=os-mynumber-admin-csv.php&msg=insert-ok&total='.$total.'&ins='.$ins.'&dup='.$dup);
					}else{
						self::os_redirect('admin.php?page=os-mynumber-admin-csv.php&msg=insert-ng');
					}
				}else{
					$message .= '<p>POST認証エラー</p>';
				}
				break;
			// CSV設定
			case 'csv-option':
				// nonceの認証成功
				if(isset($_POST) && isset($_POST['line']) && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'], $op_action)){
					// 更新
					if(MynumberCsvClass::update_csv_options($_POST)!==FALSE){
						self::os_redirect('admin.php?page=os-mynumber-admin-csv.php&msg2=update-ok');
					}else{ // 更新失敗
						self::os_redirect('admin.php?page=os-mynumber-admin-csv.php&msg2=update-ng');
					}
				}else{
					$message2 .= '<p>POST認証エラー</p>';
				}
				break;
			default:
				$itemData = MynumberSql::get_formitem_data();
		}
		include_once(OSMP_PLUGIN_INCLUDE_FILES."/admin-csvPage.php");

	}
	// Page マイナンバー提出フォームの設定
	public static function formPage(){

		global $osmp_option_data;
		$message = MynumberMessageClass::updateMessage();
		$mode = (isset($_REQUEST['mode'])) ? $_REQUEST['mode']: '';
		$user = wp_get_current_user(); // ログインユーザデータ
		$my_id = (isset($user->ID)) ? $user->ID: 0;
		$upd_action = $my_id.'_updform';
		$ins_action = $my_id.'_insform';
		$del_action = $my_id.'_delform';
		// バリデーション
		$validate = ''; $ins_validate = '';
		// 提出フォーム用ページid取得
		$get_page_pt = get_page_by_path("mynumber-form");
		$get_page_id = (isset($get_page_pt->ID)) ? $get_page_pt->ID: 0;
		// データ取得
		$data = MynumberSql::get_formitem_data();
		$new_form = array();
		$pure_data = $data; // あとで処理する可能性があるので、別名に格納
		//
		switch($mode){
			// 項目更新
			case 'upd':
				// nonceの認証成功
				if(isset($_POST) && isset($_POST['item']) && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'], $upd_action)){
					$validate = MynumberValidation::validation_formitem_upd($_POST['item']);
					// バリデーションチェックOK
					if($result = MynumberValidation::validates($validate)){
						// 更新
						if(MynumberSql::update_formitem($_POST['item'])!==FALSE){
							self::os_redirect('admin.php?page=os-mynumber-admin-form.php&msg=update-ok');
						}else{ // 失敗
							self::os_redirect('admin.php?page=os-mynumber-admin-form.php&msg=update-ng');
						}
						self::now_processing();
					}else{ // NG
						$data = self::change_formitem_post($data, $_POST['item']);
					}
				}else{
					$message .= '<p>POST認証エラー</p>';
				}
				break;
			// 項目作成
			case 'ins':
				// nonceの認証成功
				if(isset($_POST) && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'], $ins_action)){
					$ins_validate = MynumberValidation::validation_formitem_ins($_POST);
					// バリデーションチェックOK
					if($result = MynumberValidation::validates($ins_validate)){
						// 新規作成
						if(MynumberSql::insert_formitem($_POST)!==FALSE){
							self::os_redirect('admin.php?page=os-mynumber-admin-form.php&msg=insert-ok');
						}else{ // 失敗
							self::os_redirect('admin.php?page=os-mynumber-admin-form.php&msg=insert-ng');
						}
						self::now_processing();
					}else{ // NG
						$new_form = $_POST;
					}
				}else{
					$message .= '<p>POST認証エラー</p>';
				}
				break;
			// 項目削除
			case 'del':
				// nonceの認証成功
				if(isset($_POST) && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'], $del_action)){
					// 削除item_idがあれば
					if(!empty($_POST['delete_id'])){
						$item_id = $_POST['delete_id'];
						// 削除実行
						if(MynumberSql::delete_formitem($item_id)!==FALSE){
							self::os_redirect('admin.php?page=os-mynumber-admin-form.php&msg=delete-ok&id='.$item_id);
						}else{ // 失敗
							self::os_redirect('admin.php?page=os-mynumber-admin-form.php&msg=delete-ng');
						}
						self::now_processing();
					}
				}else{
					$message .= '<p>POST認証エラー</p>';
				}
				break;
			// デフォルト
			default:
		}
		//
		include_once(OSMP_PLUGIN_INCLUDE_FILES."/admin-formPage.php");

	}
	// Page 基本設定
	public static function optionPage(){

		global $osmp_option_data;
		$message = MynumberMessageClass::updateMessage();
		$mode = (isset($_REQUEST['mode'])) ? $_REQUEST['mode']: '';
		$user = wp_get_current_user(); // ログインユーザデータ
		$my_id = (isset($user->ID)) ? $user->ID: 0;
		$action = $my_id.'_option';
		$validate = '';
		//
		switch($mode){
			case 'upd':
				if(!empty($_POST) && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'], $action)){
					//
					$validate = MynumberValidation::validation_option_upd($_POST);
					// バリデーションチェックOK
					if($result = MynumberValidation::validates($validate)){
						if(MynumberSql::update_option($_POST)!==FALSE){ //成功なら
							self::os_redirect('admin.php?page=os-mynumber-admin-option.php&msg=update-ok');
						}else{ // 失敗なら
							self::os_redirect('admin.php?page=os-mynumber-admin-option.php&msg=update-error');
						}
						self::now_processing();
					}else{ // NG
						$osmp_option_data = $_POST;
					}
				}
				break;
			default:
		}
		//
		include_once(OSMP_PLUGIN_INCLUDE_FILES."/admin-optionPage.php");

	}
	// Page プラグイン管理画面用のパスワード入力ページ
	public static function adminPasswordFormPage(){

		global $osmp_option_data;
		$message = MynumberMessageClass::updateMessage();
		$mode = (isset($_REQUEST['mode'])) ? $_REQUEST['mode']: '';
		$user = wp_get_current_user(); // ログインユーザデータ
		$my_id = (isset($user->ID)) ? $user->ID: 0;
		$action = $my_id.'_pwdform';
		$reissue_action = $my_id.'_reissue';
		//
		switch($mode){
			// パスワード再発行
			case 'reissue':
				if(!empty($_POST) && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'], $reissue_action)){
					// 再発行
					if(PasswordForm::password_reissue()!==FALSE){ // OK
						self::os_redirect('admin.php?page=os-mynumber-admin.php&msg=repassword-ok');
					}else{ // NG
						self::os_redirect('admin.php?page=os-mynumber-admin.php&msg=repassword-ng');
					}
				}
				break;
			// POST、パスワードチェック
			case 'pwdform':
				if(!empty($_POST) && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'], $action)){
					$validate = MynumberValidation::validation_pwd_admin($_POST);
					// バリデーションチェックOK
					if($result = MynumberValidation::validates($validate)){
						// パスワードチェック
						if(PasswordForm::password_check($_POST['pwd'])!==FALSE){ // OK
							$now = date_i18n("Y-m-d H:i:s");
							$arr = array('password_admin_unlock_flag'=>1, 'password_admin_unlock_flag_createdata'=>$now);
							// ユーザメタ更新
							if(self::user_meta_upd($arr, $my_id)!==FALSE){ // OK
								self::os_redirect('admin.php?page=os-mynumber-admin.php&msg=password-ok');
							}else{ // NG
								self::os_redirect('admin.php?page=os-mynumber-admin.php&msg=usermeta-ng');
							}
						}else{ // NG
							self::os_redirect('admin.php?page=os-mynumber-admin.php&msg=password-ng');
						}
						self::now_processing();
					}
				}
				break;
			// デフォルト
			default:
		}
		include_once(OSMP_PLUGIN_INCLUDE_FILES."/admin-passwordFormPage.php");

	}
	// Page エラー
	public static function adminNotFoundPage(){

		$mode = (isset($_REQUEST['mode'])) ? $_REQUEST['mode']: '';
		//
		switch($mode){
			case 'comp':
				$error_code = 'code101';
				break;
			default:
				$error_code = 'code404';
		}
		include_once(OSMP_PLUGIN_INCLUDE_FILES."/admin-adminNotFoundPage.php");
		exit;

	}
	// サブメニューも上と同一ページ
	public static function adminSubPasswordFormPage(){
		self::adminPasswordFormPage();
	}
	// 管理画面フッター
	public static function custom_in_admin_footer(){

		$page = (isset($_REQUEST['page'])) ? $_REQUEST['page']: '';
		//
?>
		<script>
		// 読み込み時の動作
		j(document).ready(function(){
<?php
		// このプラグインの管理画面なら
		if(stristr($page, 'os-mynumber-')){
?>

<?php
		}
?>
		});
		</script>
<?php
	}
	// フッターのWP文言を当プラグイン用へ
	public static function custom_admin_footer_text(){

		$page = (isset($_REQUEST['page'])) ? $_REQUEST['page']: '';
		//
		if(stristr($page, 'os-mynumber-')){
?>

		当プラグインのご利用ありがとうございます。<br />
		WordPress運営でお困りの際は、お気軽に<a href="http://lp.olivesystem.jp/wordpress" target="_blank">OLIVESYSTEM.JP</a>にお問い合わせください。

<?php
		}

	}
	// フッターのWPバージョンを当プラグインバージョンへ
	public static function custom_update_footer(){

		$page = (isset($_REQUEST['page'])) ? $_REQUEST['page']: '';
		//
		if(stristr($page, 'os-mynumber-')){
?>
		プラグインバージョン<?php echo OSMP_VERSION; ?><br />WP
<?php
		}

	}
	/*
	*  メニューを呼び出す前に実行する。JSやcssの設定等
	*/
	public static function actionAdminInit(){

		$page = (isset($_REQUEST['page'])) ? $_REQUEST['page']: '';
		$mode = (isset($_REQUEST['mode'])) ? $_REQUEST['mode']: '';
		// os-mynumberを含むなら実行
		if(stristr($page, 'os-mynumber-')){
			switch($mode){
				// 画像出力
				case 'image':
					self::output_image();
					break;
				// csv出力
				case 'csv_export':
					self::output_csv();
					break;
				case 'csv_sample_export':
					self::output_csv('sample');
					break;
				// 通常
				default:
					// jQuery
					wp_enqueue_script('jquery');
					// Javascript
					$dir_ex = explode("/", rtrim(OSMP_PLUGIN_DIR, "/")); // 現在のプラグインのパス
					$now_plugin = end($dir_ex); // 現在のプラグインのディレクトリ名
					// dialog
					wp_enqueue_script('osmp-jquery-ui', plugins_url($now_plugin).'/js/jquery-ui/jquery-ui.min.js', array(), '1.0');
					// lity
					wp_enqueue_script('osmp-jquery-lity', plugins_url($now_plugin).'/js/lity/lity.min.js', array(), '1.0');
					// numeric
					wp_enqueue_script('jquery.numeric.min.js', plugins_url($now_plugin).'/js/jquery.numeric.min.js', array(), '1.0');
					// オリジナルjs
					wp_enqueue_script('osmp-j', plugins_url($now_plugin).'/js/j.js', array(), '1.0');
					// css
					wp_enqueue_style('osmp-jquery-ui', plugins_url($now_plugin).'/js/jquery-ui/jquery-ui.css', array(), '1.0');
					wp_enqueue_style('osmp-jquery-lity', plugins_url($now_plugin).'/js/lity/lity.min.css', array(), '1.0');
					wp_enqueue_style('osmp-style-admin', plugins_url($now_plugin).'/style-admin.css', array(), '1.0');
			}
		}

	}
	// 画像出力
	public static function output_image(){

		$table = (isset($_REQUEST['tbl']) && $_REQUEST['tbl']=='item') ? OSMP_DETAIL_TABLE: '';
		include_once(OSMP_PLUGIN_DIR."class/imageClass.php");
		MynumberImageClass::output_image($table);

	}
	// CSV出力
	public static function output_csv($str=''){

		include_once(OSMP_PLUGIN_DIR."class/csvClass.php");
		if($str=='sample'){
			MynumberCsvClass::sample_output_csv();
		}else{
			MynumberCsvClass::output_csv();
		}

	}
	/*
	*  その他処理
	*/
	// 検索時のメッセージ用
	public static function list_search_keyword(){
		return array(
			'last_name'=>'姓：%%value%%、', 'first_name'=>'名：%%value%%、', 'mynumber3'=>'マイナンバー下3桁：%%value%%、', 'create_time'=>'提出日：%%value%%、',
		);
	}
	// 検索メッセージの変換
	public static function seach_pmatch($str=''){

		$str = preg_replace('/-([0-9]{2})-([0-9]{2})/u', '$1月$2日', $str);
		$str = preg_replace('/([0-9]{4})-([0-9]{2})(-|月)/u', '$1年$2月', $str);
		return $str;

	}

}
?>