<?php
//
class MynumberPublic extends MynumberCommonClass {

	public function __construct(){

		parent::__construct();
		// 表示のショートコード
		add_shortcode('mynumber-form', array('MynumberPublic', 'mynumberFormView'));
		// JS、CSS読み込み
		add_action('wp_print_scripts', array('MynumberPublic', 'os_wp_enqueue'));

	}
	/*
	*  ショートコードの処理
	*/
	public static function mynumberFormView($atts, $content=null){

		extract(shortcode_atts(array(
			'id' => '',
		), $atts));
		$mode = (isset($_REQUEST['mode'])) ? $_REQUEST['mode']: '';
		$action = 'mynumber-post';
		//
		switch($mode){
			// POST時
			case 'post':
				if(!empty($_POST) && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'], $action)){
					$mynumber = (isset($_POST['mynumber'])) ? $_POST['mynumber']: '';
					// マイナンバーが重複しなければ
					if(MynumberSql::mynumber_data_check($mynumber)===FALSE){
						$form_content = '処理中です…';
						$data_id = MynumberSql::update_mynumber_data($_POST, 'insert');
						// 失敗か成功か
						if($data_id===FALSE){
							$mode = 'error';
						}else{
							$mode = 'success';
						}
					}else{
						$mode = 'duplication';
					}
				}else{
					$mode = 'no-post';
				}
				// リダイレクト
				$url = self::req_question_or_and().'mode='.$mode;
				self::os_redirect($url);
				break;
			// マイナンバー重複
			case 'duplication':
				$form_content = '<div id="mynumber-plugin"><p class="red">既に提出済みのマイナンバーです。</p></div>';
				break;
			// POST不明時
			case 'no-post':
				$form_content = '<div id="mynumber-plugin"><p class="red">失敗です！投稿処理がおかしいです。</p></div>';
				break;
			// POST成功時
			case 'success':
				$form_content = '<div id="mynumber-plugin"><p class="red">提出に成功しました！</p></div>';
				break;
			// エラー時
			case 'error':
				$form_content = '<div id="mynumber-plugin"><p class="red">提出に失敗しました！管理者にお問合せください。</p></div>';
				break;
			// 通常時
			default:
				// フォーム項目のデータ取得
				$data = MynumberSql::get_formitem_data();
				//
				ob_start();
				include_once(OSMP_PLUGIN_INCLUDE_FILES."/public-formPage.php");
				$form_content = ob_get_contents();
				ob_end_clean();
		}

		return $content.$form_content;

	}
	// ? or &
	public static function req_question_or_and(){

		if(stristr($_SERVER["REQUEST_URI"], '?')){
			return $_SERVER["REQUEST_URI"].'&';
		}else{
			return $_SERVER["REQUEST_URI"].'?';
		}

	}
	/*
	*  Javascript CSS 呼び出し
	*/
	public static function os_wp_enqueue(){

		if(self::has_shortcode('mynumber-form')==TRUE){
			// jQuery
			wp_enqueue_script('jquery');
			$dir_ex = explode("/", rtrim(OSMP_PLUGIN_DIR, "/")); // 現在のプラグインのパス
			$now_plugin = end($dir_ex); // 現在のプラグインのディレクトリ名
			// Javascript
			wp_enqueue_script('j', plugins_url($now_plugin).'/js/j.js', array(), '1.0');
			wp_enqueue_script('jquery.numeric.min.js', plugins_url($now_plugin).'/js/jquery.numeric.min.js', array(), '1.0');
			// css
			wp_enqueue_style('style', plugins_url($now_plugin).'/style.css', array(), '1.0');
		}

	}
}
?>
