<?php
//
class MynumberValidation extends MynumberValidationClass {

	public function __construct(){
		parent::__construct();
	}
	/*
	*  管理画面でのバリデーションチェック
	*/
	// 基本設定でのバリデーション
	public static function validation_option_upd($post=''){

		$validate = array();
		//
		foreach($post as $key => $p){
			switch($key){
				case 'password':
					if(!empty($post['password_flag'])){
						$this_validate = self::validation_rule($p, $key, array('empty', 'eng_symbol_numeric', 'is_n_space', 'is_n_per', array('number', 0, 100)));
						//
						if(isset($post['re_password']) && $p==$post['re_password']){

						}else{

						}
					}
					break;
				default:
					$this_validate = '';
			}
			if(!empty($this_validate)){
				// 結合
				$validate = array_merge($validate, $this_validate);
			}
		}
		// エラーがあれば
		if(!empty($validate)){
			// メッセージを修正
			$change_arr = array(
				'password'=>'パスワード',
			);
			$validate = self::validates_message($validate, $change_arr);
		}

		return $validate;

	}
	// フォーム項目更新バリデーション
	public static function validation_formitem_upd($post_array=''){

		$validate = array();
		$validate_text = array();
		//
		foreach($post_array as $i => $post){
			$item_id = (isset($post['item_id'])) ? $post['item_id']: '';
			$postid_str = '項目ID'.$item_id.'の';
			//
			foreach($post as $key => $p){
				//
				switch($key){
					// 項目名
					case 'name':
						$this_validate = self::validation_rule($p, $key, array('empty', array('number', 0, 80)), $i);
						break;
					// 項目キー
					case 'key':
						$this_validate = self::validation_rule($p, $key, array('empty', 'eng_numeric', array('number', 0, 80)), $i);
						break;
					// 何もしない
					default:
						$this_validate = '';
				}
				//
				if(!empty($this_validate)){
					// 結合
					$validate_text = array_merge($validate_text, $this_validate);
					// メッセージを修正
					$change_arr = array(
						'name'=>$postid_str.'項目名', 'key'=>$postid_str.'項目キー',
					);
					$validate_text = self::validates_message($validate_text, $change_arr);
				}
			}
			// エラーがあれば
			if(!empty($validate_text)){
				$validate_combine = array();
				// キーを修正
				foreach($validate_text as $key => $val){
					$ids = (isset($val['id'])) ? $val['id']: '';
					//
					switch($key){
						case 'name':
							$k = 'item-name'.$ids;
							break;
						case 'key':
							$k = 'item-key'.$ids;
							break;
						default:
							$k = $key;
					}
					//
					$validate_combine[$k] = $val;
				}
				// 結合
				if(!empty($validate)){
					$validate = array_merge($validate, $validate_combine);
				}else{
					$validate = $validate_combine;
				}
				unset($validate_text); unset($validate_combine);
			}
			$validate_text = array();
		}

		return $validate;

	}
	// データをPOSTの値に変換
	public static function change_formitem_post($data='', $post=''){

		if(!empty($post) && !empty($data)){
			foreach($data as $i => $d){
				foreach($d as $key => $val){
					if(isset($post[$i][$key])){
						$data[$i][$key] = $post[$i][$key];
					}
				}
				// 独自処理
				if(!empty($post[$i]['updflag'])){
					$data[$i]['updflag'] = $post[$i]['updflag'];
				}
			}
		}

		return $data;

	}
	// フォーム項目新規バリデーション
	public static function validation_formitem_ins($post=''){

		$validate = array();

		foreach($post as $key => $p){
			switch($key){
				case 'name':
					$this_validate = self::validation_rule($p, $key, array('empty', array('number', 0, 80)));
					break;
				case 'key':
					$this_validate = self::validation_rule($p, $key, array('empty', 'eng_numeric', array('number', 0, 80)));
					break;
				// デフォルト
				default:
					$this_validate = '';
			}
			// 結合
			if(!empty($validate)){
				if(is_array($this_validate)){
					$validate = array_merge($validate, $this_validate);
				}
			}else{
				if(is_array($this_validate)){
					$validate = $this_validate;
				}
			}
		}
		// エラーがあれば
		if(!empty($validate)){
			// メッセージを修正
			$change_arr = array(
				'name'=>'項目名', 'key'=>'項目キー',
			);
			$validate = self::validates_message($validate, $change_arr);
			$for_valid = $validate;
			//
			foreach($for_valid as $key => $val){
				switch ($key) {
					case 'name': case 'key':
						$validate['ins-'.$key] = $val;
						unset($validate[$key]);
						break;
				}
			}
		}

		return $validate;

	}
	// プラグイン管理画面パスワードチェック
	public static function validation_pwd_admin($post=''){

		$p = (isset($post['pwd'])) ? $post['pwd']: '';
		$validate = self::validation_rule($p, 'pwd', array('empty', 'eng_symbol_numeric', 'is_n_space', 'is_n_per', array('number', 0, 100)));
		// エラーがあれば
		if(!empty($validate)){
			// メッセージを修正
			$change_arr = array(
				'pwd'=>'パスワード',
			);
			$validate = self::validates_message($validate, $change_arr);
		}

		return $validate;

	}

}
?>